/*
Copyright (c) 2007 Hewlett-Packard development company llc
//
//  All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//  - Redistributions of source code must retain the above copyright notice,
//  this list of conditions and the disclaimer below.
//
//  - Redistributions in binary form must reproduce the above copyright notice,
//  this list of conditions and the disclaimer below in the documentation and/or
//  other materials provided with the distribution. Unless a specific license is granted
//  to te licencee
//
//  - This software can only be used on a HP hardware. You are not permited to leaverage
//  any part of this software for products/project that do not work on hardware sold by HP
//
//  HP's name may not be used to endorse or promote products derived from
//  this software without specific prior written permission.
//
//  DISCLAIMER:  THIS SOFTWARE IS PROVIDED BY HP "AS IS" AND ANY EXPRESS OR
//  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
//  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
//  DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
//  OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
//  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//  ----------------------------------------------------------------------------
file created by Cyrille de Brebisson
 */
#include "board.h"

/**! \fn Lcd_Init()
 *  @ingroup lcddriver
 * \brief initialize the LCD driver (clock, common, segments...)
 **/
void Lcd_Init(void);

/**! \fn Lcd_Display_Init()
 *  @ingroup lcddriver
 * \brief erase the screen
 **/
void Lcd_Display_Init();

/**! \fn Lcd_Enable(int contrast)
 *  @ingroup lcddriver
 * \brief init the scrren and turn it on
 **/
void Lcd_Enable(int contrast);

/**! \fn Lcd_Disable()
 *  @ingroup lcddriver
 * \brief turn LCD off
 **/
void Lcd_Disable();

/**! \fn Lcd_SetContrast(int contrast)
 *  @ingroup lcddriver
 * \brief change the LCD contrast
 **/
void Lcd_SetContrast(int contrast); // (TODO: test)

void LcdBlink(int blink);         // set LCD in blink mode or out of it (True or False)

/** @} */ // end of lcddriver group

