//  Copyright (c) 2007 Hewlett-Packard development company llc
//
//  All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//  - Redistributions of source code must retain the above copyright notice,
//  this list of conditions and the disclaimer below.
//
//  - Redistributions in binary form must reproduce the above copyright notice,
//  this list of conditions and the disclaimer below in the documentation and/or
//  other materials provided with the distribution. Unless a specific license is granted
//  to te licencee
//
//  HP's name may not be used to endorse or promote products derived from
//  this software without specific prior written permission.
//
//  DISCLAIMER:  THIS SOFTWARE IS PROVIDED BY HP "AS IS" AND ANY EXPRESS OR
//  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
//  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
//  DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
//  OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
//  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//  ----------------------------------------------------------------------------
/*
* file created by Anuj Garg
*/

/*! \HP20bButton.h HP20b LCD emulator
* 
*
*	File contains macros to create the imaginary rectangles around the buttons. 
*	File also contains the class which is responsible for the functionality of each individual button.
*	
*/
#pragma once
#include "stdafx.h"

// macros
//row1
#define Button_N		  {11, {  {48, 271 },		{88, 311	} } } 
#define Button_IYR		{12, {  {108, 271 },	{146, 311	} } } 
#define Button_PV		  {13, {  {165, 271 },	{204, 311	} } } 
#define Button_PMT		{14, {  {224, 271 },	{263, 311	} } } 
#define Button_FV	  	{15, {  {281, 271 },	{321, 311	} } } 
#define Button_AMORT	{16, {  {339, 271 },	{381, 311	} } } 

//row2
#define Button_CSHFL	{21, {  {48, 339 },		{88, 379	} } } 
#define Button_IRR		{22, {  {108, 339 },	{146, 379	} } } 
#define Button_NPV		{23, {  {165, 339 },	{204, 379	} } } 
#define Button_BOND		{24, {  {224, 339 },	{263, 379	} } }
#define Button_PERC		{25, {  {281, 339 },	{321, 379	} } } 
#define Button_RCL		{26, {  {339, 339 },	{381, 379	} } } 

//row3
#define Button_INPUT	{31, {  {48, 431  },	{146, 471	} } } 
#define Button_LEFT		{32, {  {165, 431 },	{204, 471	} } } 
#define Button_RIGHT	{33, {  {225, 431 },	{263, 471	} } } 
#define Button_PM		  {34, {  {281, 431 },	{321, 471	} } }
#define Button_ARROW	{35, {	{339, 431 },	{381, 471	} } } 

//row4
#define Button_UP		  {41, {  {48,  499 },	{102, 541	} } } 
#define Button_7		  {42, {  {118, 499 },	{171, 541	} } } 
#define Button_8		  {43, {  {187, 499 },	{242, 541	} } } 
#define Button_9		  {44, {  {257, 499 },	{312, 541	} } }
#define Button_DVD		{45, {  {324, 499 },	{381, 541	} } } 

//row5
#define Button_DN		  {51, {  {48, 567 },		{102, 610	} } } 
#define Button_4		  {52, {  {118, 567 },	{171, 610	} } } 
#define Button_5		  {53, {  {187, 567 },	{242, 610	} } } 
#define Button_6		  {54, {  {257, 567 },	{312, 610	} } }
#define Button_MUL		{55, {  {324, 567 },	{381, 610	} } } 


//row6
#define Button_SHIFT	{61, {  {48, 636 },		{102, 679	} } } 
#define Button_1		  {62, {  {118, 636 },	{171, 679	} } } 
#define Button_2	  	{63, {  {187, 636 },	{242, 679	} } } 
#define Button_3		  {64, {  {257, 636 },	{312, 679	} } }
#define Button_MNS		{65, {  {324, 636 },	{381, 679	} } } 

//row7
#define Button_ON		  {71, {	{48, 706 },		{102, 749	} } } 
#define Button_0		  {72, {  {118, 706 },	{171, 749	} } } 
#define Button_DOT		{73, {  {187, 706 },	{242, 749	} } } 
#define Button_EQUAL	{74, {	{257, 706 },	{312, 749	} } }
#define Button_PLUS		{75, {  {324, 706 },	{381, 749	} } } 

// HP Logo 
#define HP_Logo_Area	{ 0, {  {312, 50 }, {376, 90 }		} }
#define NUM_BUTTONS		37
 
typedef struct { int keyPadNum; POINT points[2]; } TButtonRect  ;

class CHP20bButton 
{
public:
	
	CHP20bButton();
	 ~CHP20bButton();

	HRGN hpGetKeyRegion(CPoint *pPtMouse, short *pKeyPadNum);	
	HRGN hpGetKeyRegion(short nKeyPadNum);
	bool hpHitTest(CPoint *pPtMouse);
};


