//  Copyright (c) 2007 Hewlett-Packard development company llc
//
//  All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//  - Redistributions of source code must retain the above copyright notice,
//  this list of conditions and the disclaimer below.
//
//  - Redistributions in binary form must reproduce the above copyright notice,
//  this list of conditions and the disclaimer below in the documentation and/or
//  other materials provided with the distribution. Unless a specific license is granted
//  to te licencee
//
//  HP's name may not be used to endorse or promote products derived from
//  this software without specific prior written permission.
//
//  DISCLAIMER:  THIS SOFTWARE IS PROVIDED BY HP "AS IS" AND ANY EXPRESS OR
//  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
//  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
//  DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
//  OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
//  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//  ----------------------------------------------------------------------------

#include "stdafx.h"
#include "HP20b_c.h"
#include "HP20b_cDlg.h"
#include "application.h"
#include "system.h"
#include "ScreenHandeling.h"// for LCD data
#include "HP20bButton.h"
#include "graphics.h"

// The compiler encountered a function that was marked with deprecated. 
// The function may no longer be supported in a future release. 
// The warning has been disabled for fopen(...) function
#pragma warning(disable : 4996)

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

extern CVirtualLCD *g_pLCD;
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	
// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnInitDialog();
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

/***************************************************************
** 
** This member function is called in response to the WM_INITDIALOG message.
** 
***************************************************************/
//
BOOL CAboutDlg::OnInitDialog()
{
	return TRUE;
}
/***************************************************************
** 
**  Function to extract the build date from globally defined 
**  variable BuildDate in Build.h 
** 
***************************************************************/
//
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHP20b_cDlg dialog
CHP20b_cDlg::CHP20b_cDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CHP20b_cDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CHP20b_cDlg)
	m_nHP20bKeyDown		= 0;
	m_Touch_Base		= NONE;
	m_bShiftKeyPressed	= false;
	m_bHideTitlebar		= false;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}
CHP20b_cDlg::~CHP20b_cDlg()
{

}

void CHP20b_cDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CHP20b_cDlg)
	DDX_Control(pDX, IDC_VIRTUAL_LCD, m_VirtualLCD);
	DDX_Control(pDX, IDC_STATIC_BG, m_Background);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CHP20b_cDlg, CDialog)
	//{{AFX_MSG_MAP(CHP20b_cDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CHAR()
	ON_WM_DESTROY()
	ON_WM_LBUTTONUP()
	ON_WM_LBUTTONDOWN()
	ON_WM_RBUTTONUP()
	ON_MESSAGE(WM_MOUSELEAVE,   OnMouseLeave)
	ON_COMMAND(ID_HP20b_ONAF, &CHP20b_cDlg::OnHP20bOnOFF)
	ON_COMMAND(ID_HP20b_ONC, &CHP20b_cDlg::OnHP20bOnC)
	ON_COMMAND(ID_HP20b_OND, &CHP20b_cDlg::OnHP20bOnD)
	ON_COMMAND(ID_HP20b_ONMINUS, &CHP20b_cDlg::OnHP20bOnMinus)
	ON_COMMAND(ID_HP20b_ONPLUS, &CHP20b_cDlg::OnHP20bOnPlus)
	ON_COMMAND(ID_HP20b_RESETSTATE, &CHP20b_cDlg::OnHP20bResetState)
	//}}AFX_MSG_MAP
	ON_COMMAND(ID_HP20b_COPYTOCLIPBOARD, &CHP20b_cDlg::OnHP20bCopytoclipboard)
	ON_WM_ACTIVATE()
	ON_COMMAND(ID_HP20b_PCCALC1, &CHP20b_cDlg::OnHP20bPccalc1)
	ON_COMMAND(ID_HP20b_PCCALC2, &CHP20b_cDlg::OnMenu)
	ON_COMMAND(ID_HP20b_PCCALC3, &CHP20b_cDlg::OnHP20bPccalc3)
	ON_COMMAND(ID_HP20b_PCCALC4, &CHP20b_cDlg::OnHP20bPccalc4)
	ON_COMMAND(ID_HP20b_PCCALC5, &CHP20b_cDlg::OnHP20bPccalc5)
	ON_WM_LBUTTONDBLCLK()
	ON_COMMAND(ID_HP20b_EXIT, &CHP20b_cDlg::OnHP20bExit)
	ON_COMMAND(ID_HP20b_SHOWCAPTION, &CHP20b_cDlg::OnHP20bShowTitlebar)
	//ON_WM_NCLBUTTONUP()
	ON_COMMAND(ID_HELP_ABOUTBOX, &CHP20b_cDlg::OnHelpAboutbox)
	ON_COMMAND(ID_HELP_HP20BBUSINESSCONSULTANT, &CHP20b_cDlg::OnHelpHp20bbusinessconsultant)
	ON_COMMAND(ID_BUY, &CHP20b_cDlg::OnBuy)
	ON_COMMAND(ID_HP20b_SHOWCAPTION_MENU, &CHP20b_cDlg::OnHP20bShowcaptionMenu)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHP20b_cDlg message handlers

CRITICAL_SECTION criticalsection;

void KeyPressMutex(int s)
{
  EnterCriticalSection(&criticalsection);
  KeyPress(s);
  LeaveCriticalSection(&criticalsection);
}

int TestVoltage(int min, int max)
{
  return 30;
}

HANDLE Pipe= 0, scgenPipe = 0, scgenreadPipe = 0;
CHP20b_cDlg *dlg;

# define BIN_LEN 161
// normaly, if you were enabeling a test system, you would have your application update the 2 following variables...
char TopLine[100] =""; 
char BottomLine[100] =""; 
unsigned long __stdcall pipethread(void *p)
{
  u64 f, t1, t2;
  QueryPerformanceFrequency((LARGE_INTEGER*)&f); f/= 10;
  QueryPerformanceCounter((LARGE_INTEGER*)&t1);
  t1= t1+f;
	unsigned long br;
	while (1)
	{
		unsigned long long *e= (unsigned long long *)AT91C_SLCDC_MEM;
		char s[20];
		if (ReadFile(Pipe, &s, 1, &br, NULL))
		{
//			for (int ir=0; ir<br; ir++) //
			if (br==1)
			{
				//        dlg->keypress(s);
				if(s[0]== 'T')
				{
          updatescreen(MyApplication);
	        QueryPerformanceCounter((LARGE_INTEGER*)&t2);
	        if (t2>t1) { t1= t2+f; UpdateDlgScreen(); }
					unsigned char c;
					c= strlen(TopLine );			// (TopLine);
					WriteFile(Pipe, &c, 1, &br, NULL);
					if (c!=0) 
					WriteFile(Pipe, TopLine, strlen(TopLine), &br, NULL);

					c= strlen(BottomLine );			// (BottomLine);
					WriteFile(Pipe, &c, 1, &br, NULL);
					if (c!=0) 
					WriteFile(Pipe, BottomLine, strlen(BottomLine), &br, NULL);
					
				}else if(s[0]== 'Q'){
          updatescreen(MyApplication);
	        QueryPerformanceCounter((LARGE_INTEGER*)&t2);
	        if (t2>t1) { t1= t2+f; UpdateDlgScreen(); }
					char LCDString[161] = {'\0'};
					unsigned int *binStr = AT91C_SLCDC_MEM;

					for(int i = 0; i<20; i++)//convert LCDdata in to series of Hex chars	
					{
						char numstr[9];
						char val[9]= {'\0'};
						unsigned int l = *binStr++;
						sprintf(numstr, "%X", l); 
						int len = strlen(numstr); 
						memset((char *)val, '0' ,8-len);
						val[8-len] = '\0';
						strcat(val,numstr);
						strcat(LCDString, val);
					}
					unsigned char c = BIN_LEN;
					WriteFile(Pipe, &c, 1, &br, NULL);
					WriteFile(Pipe, LCDString, strlen(LCDString), &br, NULL);
				}else{
          KeyPressMutex(s[0]);
//          updatescreen(calc);
//          UpdateDlgScreen();
//          WriteFile( Pipe, "#", 1, &br, NULL );
				}
			}else 
			{ 
			  updatescreen(MyApplication);
        UpdateDlgScreen();
			  Sleep(100);
		  }
		}else Sleep(1000); // waiting for someone else to open the pipe...
	}
}


HANDLE KeyEvent;

void UpdateDlgScreen()
{
  SendMessage(dlg->m_hWnd, WM_CHAR, '[', 0); //used to force a screen refresh...	
}

unsigned long __stdcall CalculationThread(void *p)
{
  while (1)
  {
    WaitForSingleObject(KeyEvent, INFINITE);
    int a;
    while ((a= KeyBuffGetKey())!=-1) KeyPressMutex(a);
    updatescreen(MyApplication);
    UpdateDlgScreen();
  }
}


BOOL CHP20b_cDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	dlg= this;

	((CHP20b_cApp *)AfxGetApp())->m_hwndDialog = m_hWnd;
	g_pLCD = &m_VirtualLCD;

	InitializeCriticalSection(&criticalsection);
	initKeyBuffer();
	init();
	ReadHP20bState(); // load saved state file if exists ....

	updatescreen(MyApplication);
	UpdateDlgScreen();
#ifdef TEST_SYSTEM
	MakeTestSystemReady();
#else
	RemoveTestSystemItem();
#endif
	KeyEvent= CreateEvent(NULL, false, false, "");

	unsigned long id;
	CreateThread(NULL, 0, CalculationThread, NULL, 0, &id);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

/***************************************************************
** 
** Function is responsible to open a pipe and start a thread for 
** test bench software. To use this functionality, please  ensure that 
** the TEST_SYSTEM directive should be enabled in the preprocessor 
** directive option of the project.
** 
***************************************************************/
//
void CHP20b_cDlg::MakeTestSystemReady()
{
	scgenPipe= CreateNamedPipe("\\\\.\\pipe\\scgen", 
					 PIPE_ACCESS_DUPLEX, 
					 PIPE_TYPE_BYTE|PIPE_READMODE_BYTE|PIPE_WAIT, 
					 1, 0, 0, 0, NULL);

	if (INVALID_HANDLE_VALUE!=Pipe){
		unsigned long tid;
		CreateThread(NULL, 0, pipethread, NULL, 0, &tid);
	}
	if( INVALID_HANDLE_VALUE != scgenPipe ){
//		unsigned long scgentid;
	}

	
}
/***************************************************************
** 
** Function is responsible to remove Test System related menus  
** 
***************************************************************/
//
void CHP20b_cDlg::RemoveTestSystemItem()
{
	// Remove 'Test System' menu 
	CMenu *pMenu = GetMenu();
	for (unsigned int i = 0; i < pMenu->GetMenuItemCount(); i++){
		CString str;
		pMenu->GetMenuStringA(i, str, MF_BYPOSITION);
		if ( str.CompareNoCase("Test") == 0 ) { pMenu->RemoveMenu(i,MF_BYPOSITION); break; }
	}

	// Remove "Special Keys"  menu
	for (unsigned int i = 0; i < pMenu->GetMenuItemCount(); i++){
		CString str;
		pMenu->GetMenuStringA(i, str, MF_BYPOSITION);
		if ( str.CompareNoCase("Special Keys") == 0 ) { pMenu->RemoveMenu(i,MF_BYPOSITION); break; }
	}

	// Remove "Copy Screen To Clipboard" sub menu
	for (unsigned int i = 0; i < pMenu->GetMenuItemCount(); i++){
		CMenu *pSub = pMenu->GetSubMenu(i);
		bool  removed  = false;
		for (unsigned int i = 0; i < pSub->GetMenuItemCount(); i++){
			CString str;
			pSub->GetMenuStringA(i, str, MF_BYPOSITION);
			if ( str.CompareNoCase("Copy Screen To Clipboard") == 0 ) {
				pSub->RemoveMenu(i,MF_BYPOSITION); removed  = true; break; 
			}
		}
		if(removed) break;
	}
	// redraws the menu bar 
	DrawMenuBar();
}


void CHP20b_cDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	} 
	else
	{
		// If the title bar is hidden, do not accept ALT key
		if(m_bHideTitlebar)
			if ( nID == SC_KEYMENU )
				return;

		CDialog::OnSysCommand(nID, lParam);
	}
}

/***************************************************************
** 
** Override function to filter VK_F10 keystroke. Pressing F10 doesn't generate WM_KEYDOWN.
** F10 is a special key used to activate menu bar.
**
***************************************************************/
//
BOOL CHP20b_cDlg::PreTranslateMessage( MSG* pMsg )
{
	if((pMsg->wParam - VK_F1 + 1) == 10/*VK_F10*/) {
		if (pMsg->message == WM_SYSKEYDOWN) 
			HP20bKeyDown(VK_F10);
		else if (pMsg->message == WM_SYSKEYUP) 
			HP20bKeyUp(VK_F10);
		return 1;
	}
	if (pMsg->message == WM_KEYDOWN) { 	HP20bKeyDown(pMsg->wParam); 	return 1;  }
	else if (pMsg->message == WM_KEYUP) { 	HP20bKeyUp(pMsg->wParam); 	return 1; }

	return CDialog::PreTranslateMessage(pMsg);
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.
void CHP20b_cDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CHP20b_cDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CHP20b_cDlg::keypress(int a)
{
  System.KeyboardMap|= KeyCodeToKeyMap(a);
  AddKeyInBuffer(a);
  SetEvent(KeyEvent); 
}

void CHP20b_cDlg::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
  if (nChar!='[')
    keypress(nChar); 
  else {
    UpdateScreenContent(); // copy the graphics on the PC screen
  }
}

/***************************************************************
** 
** Responsible to add the virtual key code of the current pressed key,
** and fire a WM_KEYUP message for the previous key which the user has 
** not released.
**
***************************************************************/
//
void CHP20b_cDlg::ForceHP20bKeyUp(WPARAM wKeyCode)
{
	if(m_listKeyCode.size() > 0)
	{
		list<WPARAM>::iterator iter;
		bool already_exists = false;
		for (iter = m_listKeyCode.begin(); iter != m_listKeyCode.end(); ++iter){
			if(*iter == wKeyCode){	already_exists = true; break ; }
		}
		if(!already_exists)	{		
			for (iter = m_listKeyCode.begin(); iter != m_listKeyCode.end(); ){
				HP20bKeyUp(*iter);	
				iter = m_listKeyCode.erase(iter);
			}
			m_listKeyCode.push_back(wKeyCode);
		}
	}
	else
		m_listKeyCode.push_back(wKeyCode);
}

/***************************************************************
** 
** Responsible to trap keystrokes for non-system keys. Once trapped, 
** calls the keypress(...) function
**
***************************************************************/
//
void CHP20b_cDlg::HP20bKeyDown(WPARAM wKeyCode)
{
	ForceHP20bKeyUp(wKeyCode);
	
	if(m_Touch_Base == NONE)
	{
		if(m_wLastVirtualKey != wKeyCode)
		{
			short key_num = 0;
			switch (wKeyCode){
				// shift key 
				case VK_LSHIFT:
				case VK_RSHIFT:
				case VK_SHIFT:	m_bShiftKeyPressed = true; break;

				// row1
				case 78		:																// key N		
				case VK_F1	:	keypress(key_num = 11);		break;							// key F1
				case 89		:																// key Y
				case VK_F2	:	keypress(key_num = 12);		break;							// key F2
				case 80		: 																// key P
				case VK_F3	:	keypress(key_num = 13);		break;							// key F3
				case 77		:																// key M
				case VK_F4	:	keypress(key_num = 14);		break;							// key F4
				case 70		:																// key F
				case VK_F5	:	keypress(key_num = 15);		break;							// key F5
				case 65		:																// key A
				case VK_F6	:	keypress(key_num = 16);		break;							// key F6

				//row2
				case 67		:																// key C
				case VK_F7	:	keypress(key_num = 21);		break;							// key F7
				case 73		:																// key I
				case VK_F8	:	keypress(key_num = 22);		break;							// key F8
				case 86		:																// key V
				case VK_F9	:	keypress(key_num = 23);		break;							// key F9
				case 66		:																// key B
				case VK_F10	:	keypress(key_num = 24);		break;							// key F10
				case 53		:	if(!m_bShiftKeyPressed)		keypress(key_num = 53);			// key 5
								else 						keypress(key_num = 25);			// key %
								break;
				case VK_F11	:	keypress(key_num = 25);		break;							// key F11
				case 82		:																// key R			
				case VK_F12	:	keypress(key_num = 26);		break;							// key F12

				//row3
				case 13		:	keypress(key_num = 31);		break;
				case 57		:	if(!m_bShiftKeyPressed)		keypress(key_num = 44);			// key 9
								else 						keypress(key_num = 32);			// key (
								break;
				case 48		:	if(!m_bShiftKeyPressed)		keypress(key_num = 72);			// key 0
								else						keypress(key_num = 33);			// key )
								break;
				case 87		:	keypress(key_num = 34);		break;							//+/-
				case 8		:	keypress(key_num = 35);		break;

				//row4
				case 38		:	keypress(key_num = 41);		break;							// key Up Arrow
				case 103	:	keypress(key_num = 42);		break;							// key Numpad(7)
				case 55		:	if (!m_bShiftKeyPressed)	keypress(key_num = 42); break;	// key (7)
				case 104	:
				case 56		:	if(!m_bShiftKeyPressed)		keypress(key_num = 43);			// key Numpad(8)
								else						keypress(key_num = 55);			// key *
								break;
				case 105	:	keypress(key_num = 44);		break;							// key Numpad(9)
				case 111	:	keypress(key_num = 45);		break;							// key Numpad(/)
				case 191	:   if (!m_bShiftKeyPressed)	keypress(key_num = 45); break;	// key (/)
				
				//row5
				case 40		:	keypress(key_num = 51);		break;							// key Down Arrow
				case 100	:	keypress(key_num = 52);		break;							// key Numpad(4)
				case 52		:	if (!m_bShiftKeyPressed)	keypress(key_num = 52); break;	// key (4)
				case 101	:	keypress(key_num = 53);		break;							// key Numpad(5)
				case 102	:	keypress(key_num = 54);		break;							// key Numpad(6)
				case 54		:	if (!m_bShiftKeyPressed)	keypress(key_num = 54); break;	// key (6)
				case 106	:	keypress(key_num = 55);		break;							// key Numpad(*)
				
					
				//row6
				case 17		:	keypress(key_num = 61);		break;							// key CTRL
				case 97		:	keypress(key_num = 62);		break;							// key Numpad(1)
				case 49		:	if (!m_bShiftKeyPressed)	keypress(key_num = 62); break;	// key (1)
				case 98		:	keypress(key_num = 63);		break;							// key Numpad(2)
				case 50		:	if (!m_bShiftKeyPressed)	keypress(key_num = 63); break;	// key (2)
				case 99		:	keypress(key_num = 64);		break;							// key Numpad(3)
				case 51		:	if (!m_bShiftKeyPressed)	keypress(key_num = 64); break;	// key (3)
				case 109	:	
				case 189	:	keypress(key_num = 65);		break;							// key Numpad(-)

				//row7
				case 27		:	keypress(key_num = 71);		break;							// key Esc
				case 96		:	keypress(key_num = 72);		break;							// key Numpad(0)
				case 110	:	keypress(key_num = 73);		break;							// key Numpad(.)
				case 190	:	if (!m_bShiftKeyPressed)	keypress(key_num = 73); break;	// key (.)
				case 187	:	if(!m_bShiftKeyPressed)		keypress(key_num = 74);			// key =
								else						keypress(key_num = 75);			// key +
								break;
				case 107	:	keypress(key_num = 75);		break;							// key Numpad(+)
		 
			}
			
			if(key_num > 0){
				m_nHP20bKeyDown = key_num;
				CHP20bButton HP20b_btn;
				m_rgnPressedButton = HP20b_btn.hpGetKeyRegion(m_nHP20bKeyDown);
				HDC hDC = ::GetDC(m_Background.m_hWnd);
				InvertRgn(hDC, m_rgnPressedButton);
				::ReleaseDC(m_Background.m_hWnd, hDC);
				m_wLastVirtualKey = wKeyCode;
				m_Touch_Base = KEYBOARD;

			}
		}
	}
}



/***************************************************************
** 
** Responsible to trap keystrokes for non-system keys. Once trapped, 
** calls the keypress(...) function
**
***************************************************************/
//
void CHP20b_cDlg::HP20bKeyUp(WPARAM wKeyCode)
{
	if(	wKeyCode == VK_LSHIFT || wKeyCode == VK_RSHIFT || wKeyCode == VK_SHIFT)
		m_bShiftKeyPressed = false; 
	
	if(m_nHP20bKeyDown > 0){
	//	TRACE1("\n m_nHP20bKeyDown = %d", m_nHP20bKeyDown);
	//	System.KeyboardMap&= ~KeyCodeToKeyMap(m_nHP20bKeyDown);
		CHP20bButton HP20b_btn;
		m_rgnPressedButton = HP20b_btn.hpGetKeyRegion(m_nHP20bKeyDown);
		HDC hDC = ::GetDC(m_Background.m_hWnd);
		InvertRgn(hDC, m_rgnPressedButton);
		::ReleaseDC(m_Background.m_hWnd, hDC);
	
		System.KeyboardMap&= ~KeyCodeToKeyMap(m_nHP20bKeyDown);

		m_nHP20bKeyDown = 0;
		m_wLastVirtualKey = 0;
		m_Touch_Base = NONE;
	}
}

/***************************************************************
** 
**  Dump the current HP20b State to the file.
**
***************************************************************/
//
void CHP20b_cDlg::SaveHP20bState()
{
	FILE *fp;
	fp = fopen("HP20bState.bin", "wb");
	if (!fp)
		return ;
	fwrite(MyApplication, sizeof(*MyApplication),1,fp);
	fclose(fp);

}
/***************************************************************
** 
**  Responsible to read the last saved state
**
***************************************************************/
//
void CHP20b_cDlg::ReadHP20bState()
{
	FILE *fp;
	fp = fopen("HP20bState.bin", "rb");
	if (!fp)
		return ;
	fread(MyApplication, sizeof(*MyApplication),1,fp);
	fclose(fp);
  UpdateDlgScreen();
  ReadRegistry();
}

/***************************************************************
** 
**  Called to inform the CWnd object that it is being destroyed.
**
***************************************************************/
//
void CHP20b_cDlg::OnDestroy()
{
	CDialog::OnDestroy();
	SaveHP20bState();
	WriteToRegistry();
#ifdef  TEST_SYSTEM
	if(Pipe!= NULL) { CloseHandle(Pipe); Pipe = NULL; }
#endif
}


// The scriptGenpipethread() function will be called each time the calculator key will be pressed will 
// send the LCD data in binary and decimal format to test bench for script generation. 
void CHP20b_cDlg::scriptGenPipeComm()
{
	unsigned long br;
	
	char LCDString[161] = {'\0'};
	unsigned int *binStr = AT91C_SLCDC_MEM;
	
	// Sending binary data
	for(int i = 0; i<20; i++)//convert LCDdata in to series of Hex chars	
	{
	  char numstr[9];
	  char val[9]= {'\0'};
	  //unsigned int l = *binStr++;
	  unsigned int l = *binStr++;
	  //binStr++;

	  sprintf(numstr, "%X", l); 
	  int len = strlen(numstr); 
	  memset((char *)val, '0' ,8-len);
	  val[8-len] = '\0';
	  strcat(val,numstr);
	  strcat(LCDString, val);
	}
	unsigned char c;
//	unsigned char c = 'a';//BIN_LEN;
	WriteFile(scgenPipe, &c, 1, &br, NULL);					// Sending binary data buffer size
	WriteFile(scgenPipe, LCDString, 161, &br, NULL);		// Sending binary data

	// Sending decimals top line bottom line and annunciator line of calculator

	c= strlen(TopLine );			// (TopLine);
	WriteFile(scgenPipe, &c, 1, &br, NULL);											// Sending topline buffer size
	if (c!=0) 
	WriteFile(scgenPipe, TopLine, strlen(TopLine), &br, NULL);			// Sending topline

	c= strlen(BottomLine );			// (BottomLine);
	WriteFile(scgenPipe, &c, 1, &br, NULL);											// Sending bottom line
	if (c!=0) 
	WriteFile(scgenPipe, BottomLine, strlen(BottomLine), &br, NULL);	// Sending bottom line
	
	//calc->TopLine[0]=0;
	//calc->BottomLine[0]=0;
	//indicString[0]=0;
}

/***************************************************************
 *This function is used to communicate the with script generator of the test bench and is not the part of end product.
 * Function will receive the key pad number as function argument and what key should be sent to script generator will be
 * decided by decision logic written inside the function. After deciding which key is to sent to script generator function will 
 * write the key on named pipe.
 * Return  void
 * Parameter  int keyPadNum
***************************************************************/
//
void CHP20b_cDlg::SendKeyToPort( int keyPadNum ) 
{
    unsigned long br;   // This variable is used for count bytes read. 
    switch( keyPadNum ){
		case 11: WriteFile( scgenPipe, "n", 1, &br, NULL ); break;
		case 12: WriteFile( scgenPipe, "i", 1, &br, NULL ); break;
		case 13: WriteFile( scgenPipe, "p", 1, &br, NULL ); break;
		case 14: WriteFile( scgenPipe, "m", 1, &br, NULL ); break;
		case 15: WriteFile( scgenPipe, "f", 1, &br, NULL ); break;
		case 16: WriteFile( scgenPipe, "a", 1, &br, NULL ); break;
		case 21: WriteFile( scgenPipe, "c", 1, &br, NULL ); break;
		case 22: WriteFile( scgenPipe, "I", 1, &br, NULL ); break;
		case 23: WriteFile( scgenPipe, "d", 1, &br, NULL ); break;
		case 24: WriteFile( scgenPipe, "B", 1, &br, NULL ); break;
		case 25: WriteFile( scgenPipe, "%", 1, &br, NULL ); break;
		case 26: WriteFile( scgenPipe, "r", 1, &br, NULL ); break;
		case 31: WriteFile( scgenPipe, "N", 1, &br, NULL ); break;
		case 32: WriteFile( scgenPipe, "(", 1, &br, NULL ); break;
		case 33: WriteFile( scgenPipe, ")", 1, &br, NULL ); break;
		case 34: WriteFile( scgenPipe, "P", 1, &br, NULL ); break;
		case 35: WriteFile( scgenPipe, "b", 1, &br, NULL ); break;
		case 41: WriteFile( scgenPipe, "U", 1, &br, NULL ); break;
		case 42: WriteFile( scgenPipe, "7", 1, &br, NULL ); break;
		case 43: WriteFile( scgenPipe, "8", 1, &br, NULL ); break;
		case 44: WriteFile( scgenPipe, "9", 1, &br, NULL ); break;
		case 45: WriteFile( scgenPipe, "/", 1, &br, NULL ); break;
		case 51: WriteFile( scgenPipe, "D", 1, &br, NULL ); break;
		case 52: WriteFile( scgenPipe, "4", 1, &br, NULL ); break;
		case 53: WriteFile( scgenPipe, "5", 1, &br, NULL ); break;
		case 54: WriteFile( scgenPipe, "6", 1, &br, NULL ); break;
		case 55: WriteFile( scgenPipe, "*", 1, &br, NULL ); break;
		case 61: WriteFile( scgenPipe, "s", 1, &br, NULL ); break;
		case 62: WriteFile( scgenPipe, "1", 1, &br, NULL ); break;
		case 63: WriteFile( scgenPipe, "2", 1, &br, NULL ); break;
		case 64: WriteFile( scgenPipe, "3", 1, &br, NULL ); break;
		case 65: WriteFile( scgenPipe, "-", 1, &br, NULL ); break;
		case 71: WriteFile( scgenPipe, "O", 1, &br, NULL ); break;
		case 72: WriteFile( scgenPipe, "0", 1, &br, NULL ); break;
		case 73: WriteFile( scgenPipe, ".", 1, &br, NULL ); break;
		case 74: WriteFile( scgenPipe, "=", 1, &br, NULL ); break;
		case 75: WriteFile( scgenPipe, "+", 1, &br, NULL ); break;
	}
	updatescreen(MyApplication);
	scriptGenPipeComm();			// Function will send the LCD data in binary and deciaml format
}


/***************************************************************
** 
** Called when the user releases the left mouse button on the button image 
** displayed on the calculator. Function is responsible to invert the color 
** of the selected button image.
**
***************************************************************/
//
void CHP20b_cDlg::OnLButtonUp(UINT nFlags, CPoint point)
{
	if(NULL != m_rgnPressedButton && MOUSE == m_Touch_Base){
		HDC hDC = ::GetDC(m_Background.m_hWnd);
		InvertRgn(hDC, m_rgnPressedButton);
		::ReleaseDC(m_Background.m_hWnd, hDC);
		
		System.KeyboardMap&= ~KeyCodeToKeyMap(m_nCurKeyPadNum);

#ifdef TEST_SYSTEM			
		SendKeyToPort(m_nCurKeyPadNum);
#endif
		m_rgnPressedButton = NULL; m_nCurKeyPadNum = 0;
	}
	if(MOUSE == m_Touch_Base)
		m_Touch_Base = NONE;

	CDialog::OnLButtonUp(nFlags, point);
}

/***************************************************************
** 
**  Called when the user presses  the left mouse button on the button image 
**  displayed on the calculator. Function is responsible to invert the color 
**  of the selected button image.
**
***************************************************************/
//
void CHP20b_cDlg::OnLButtonDown(UINT nFlags, CPoint point)
{
	if(m_Touch_Base == NONE) {
		CHP20bButton btn;
		m_rgnPressedButton =  btn.hpGetKeyRegion(&point, &m_nCurKeyPadNum);
		if(NULL != m_rgnPressedButton){

			keypress(m_nCurKeyPadNum);
			HDC hDC = ::GetDC(m_Background.m_hWnd);
			InvertRgn(hDC, m_rgnPressedButton);
			::ReleaseDC(m_Background.m_hWnd, hDC);
			
			//track when the mouse pointer leaves a window
			TRACKMOUSEEVENT tme; 
			tme.cbSize = sizeof(tme); tme.hwndTrack = m_hWnd; tme.dwFlags = TME_LEAVE;
			_TrackMouseEvent(&tme);
		}
		m_Touch_Base = MOUSE;
	}

	if(NULL == m_rgnPressedButton){
		//To move HP20b without title bar
		m_Touch_Base = NONE;
		SendMessage(WM_NCLBUTTONDOWN, HTCAPTION, 0);
	}
	CDialog::OnLButtonDown(nFlags, point);
}


/***************************************************************
** 
**  Called when the user releases the right mouse button on HP-Logo.  
**  This function is responsible to display the short cut menu.
**
***************************************************************/
//
void CHP20b_cDlg::OnRButtonUp(UINT nFlags, CPoint point)
{
	CHP20bButton btn;
	if(btn.hpHitTest(&point)) {
		CMenu *pMenu = new CMenu;
#ifndef TEST_SYSTEM	
		pMenu->LoadMenuA(MAKEINTRESOURCE(IDR_MENU3));		
#else
		pMenu->LoadMenuA(MAKEINTRESOURCE(IDR_MENU1));
		UpdateTestbenchMenu(pMenu);
#endif
		// check/uncheck the 'test System' menu item
		if(m_bHideTitlebar)
			pMenu->CheckMenuItem(ID_HP20b_SHOWCAPTION, MF_BYCOMMAND | MF_CHECKED);
		else
			pMenu->CheckMenuItem(ID_HP20b_SHOWCAPTION, MF_BYCOMMAND | MF_UNCHECKED);

		
		
		ClientToScreen(&point);
		pMenu->GetSubMenu(0)->TrackPopupMenu(TPM_RIGHTBUTTON, point.x, point.y, this, NULL);
			
		delete pMenu;
	}
	CDialog::OnRButtonUp(nFlags, point);
}

/***************************************************************
** 
**  Called when the mouse pointer leaves a window or hovers over a window for a specified amount of time
**
***************************************************************/
//
 
LPARAM CHP20b_cDlg::OnMouseLeave(WPARAM wp, LPARAM lp)
{
	SendMessage(WM_LBUTTONUP, 0,0);
	return 0;
}


/***************************************************************
** 
**  Called when the user presses 'On OFF' sub-menu
**
***************************************************************/
//
void CHP20b_cDlg::OnHP20bOnOFF()
{
	keypress(85);
}

/***************************************************************
** 
**  Called when the user presses 'On C' sub-menu
**
***************************************************************/
//
void CHP20b_cDlg::OnHP20bOnC()
{
	keypress(83);
}

/***************************************************************
** 
**  Called when the user presses 'On D' sub-menu
**
***************************************************************/
//
void CHP20b_cDlg::OnHP20bOnD()
{
	keypress(84);
}

/***************************************************************
** 
**  Called when the user presses 'On -' sub-menu
**
***************************************************************/
//
void CHP20b_cDlg::OnHP20bOnMinus()
{
	keypress(82);
}

/***************************************************************
** 
**  Called when the user presses 'On +' sub-menu
**
***************************************************************/
//
void CHP20b_cDlg::OnHP20bOnPlus()
{
	keypress(81);
}

/***************************************************************
** 
**  Called when the user presses 'CopyToClipboard' sub-menu
**
***************************************************************/
//
void CHP20b_cDlg::OnHP20bCopytoclipboard()
{
	m_VirtualLCD.hpCopyToClipboard();
}

/***************************************************************
** 
**  Called when the user presses 'Reset State' sub-menu
**
***************************************************************/
void CHP20b_cDlg::OnHP20bResetState()
{
	if(AfxMessageBox("Are you sure that you want to reset the calculator?", MB_YESNO | MB_ICONINFORMATION) == IDYES){
		init();
		updatescreen(MyApplication);
		UpdateDlgScreen();
	}
}

void CHP20b_cDlg::OnHP20bPccalc1()
{
	if(Pipe!= NULL) { CloseHandle(Pipe); Pipe = NULL; }
	Pipe= CreateNamedPipe("\\\\.\\pipe\\Test-Bench", 
						 PIPE_ACCESS_DUPLEX, 
						 PIPE_TYPE_BYTE|PIPE_READMODE_BYTE|PIPE_WAIT, 
						 1, 0, 0, 0, NULL);
	m_nCurrentTestbenchId = ID_HP20b_PCCALC1;
	UpdateTestbenchMenu();
}

void CHP20b_cDlg::OnMenu()
{
	if(Pipe!= NULL) { CloseHandle(Pipe); Pipe = NULL; }
	Pipe= CreateNamedPipe("\\\\.\\pipe\\Test-Bench2", 
						 PIPE_ACCESS_DUPLEX, 
						 PIPE_TYPE_BYTE|PIPE_READMODE_BYTE|PIPE_WAIT, 
						 1, 0, 0, 0, NULL);
	m_nCurrentTestbenchId = ID_HP20b_PCCALC2;
	UpdateTestbenchMenu();
}

void CHP20b_cDlg::OnHP20bPccalc3()
{
	if(Pipe!= NULL) { CloseHandle(Pipe); Pipe = NULL; }
	Pipe= CreateNamedPipe("\\\\.\\pipe\\Test-Bench3", 
						 PIPE_ACCESS_DUPLEX, 
						 PIPE_TYPE_BYTE|PIPE_READMODE_BYTE|PIPE_WAIT, 
						 1, 0, 0, 0, NULL);
	m_nCurrentTestbenchId = ID_HP20b_PCCALC3;
	UpdateTestbenchMenu();
}

void CHP20b_cDlg::OnHP20bPccalc4()
{
	if(Pipe!= NULL) { CloseHandle(Pipe); Pipe = NULL; }
	Pipe= CreateNamedPipe("\\\\.\\pipe\\Test-Bench4", 
					 PIPE_ACCESS_DUPLEX, 
					 PIPE_TYPE_BYTE|PIPE_READMODE_BYTE|PIPE_WAIT, 
					 1, 0, 0, 0, NULL);
	m_nCurrentTestbenchId = ID_HP20b_PCCALC4;
	UpdateTestbenchMenu();
}

void CHP20b_cDlg::OnHP20bPccalc5()
{
	if(Pipe!= NULL) { CloseHandle(Pipe); Pipe = NULL; }
	Pipe= CreateNamedPipe("\\\\.\\pipe\\Test-Bench5", 
					 PIPE_ACCESS_DUPLEX, 
					 PIPE_TYPE_BYTE|PIPE_READMODE_BYTE|PIPE_WAIT, 
					 1, 0, 0, 0, NULL);
	m_nCurrentTestbenchId = ID_HP20b_PCCALC5;
	UpdateTestbenchMenu();
}

/***************************************************************
** 
**  Called when the user double-clicks the left mouse button on the button image 
**  displayed on the calculator. Function is responsible to invert the color 
**  of the selected button image.
**
***************************************************************/
//
void CHP20b_cDlg::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	CHP20bButton btn;
	m_rgnPressedButton =  btn.hpGetKeyRegion(&point, &m_nCurKeyPadNum);
	if(NULL != m_rgnPressedButton)
	{
		m_Touch_Base = MOUSE;
  		keypress(m_nCurKeyPadNum);
		HDC hDC = ::GetDC(m_Background.m_hWnd);
		InvertRgn(hDC, m_rgnPressedButton);
		::ReleaseDC(m_Background.m_hWnd, hDC);
		System.KeyboardMap&= ~KeyCodeToKeyMap(m_nCurKeyPadNum);
#ifdef TEST_SYSTEM	
		//SendKeyToPort(m_nCurKeyPadNum);

#endif
	}
	CDialog::OnLButtonDblClk(nFlags, point);
}

/***************************************************************
** 
**  Called when the user presses 'Exit' sub-menu
**  
***************************************************************/
void CHP20b_cDlg::OnHP20bExit()
{
	SendMessage(WM_CLOSE, 0, 0);
}

/***************************************************************
** 
**  Called when the user presses 'Hide Titlebar' sub-menu
**  
***************************************************************/
void CHP20b_cDlg::OnHP20bShowTitlebar()
{
	ShowHP20bTitlebar();

	// check/uncheck main menu
	CMenu *pMenu = GetMenu();
	if(m_bHideTitlebar)
		pMenu->CheckMenuItem(ID_HP20b_SHOWCAPTION, MF_BYCOMMAND | MF_CHECKED);
	else
		pMenu->CheckMenuItem(ID_HP20b_SHOWCAPTION, MF_BYCOMMAND | MF_UNCHECKED);

}

/***************************************************************
** 
**  To show/hide the Title bar of the application window.     
**  This is also responsible to set the window region.   
**  
***************************************************************/
//
void CHP20b_cDlg::ShowHP20bTitlebar()
{
	if(m_bHideTitlebar){
		// Display title bar
		SetWindowLong(m_hWnd, GWL_STYLE, GetWindowLong(m_hWnd, GWL_STYLE)|WS_CAPTION); 
		SetWindowRgn(NULL, true);
	}
	else{
		// Remove title bar	
		//static POINT const table[116]= { {26, 8+21 }, {400, 8+21 }, {403, 8+21}, {406, 8+21 }, {409, 9+21 }, {411, 10 +21}, {412, 10 +21}, {414, 11 +21}, {415, 12 +21}, {416, 13 +21}, {417, 14 +21}, {418, 15 +21}, {419, 17 +21}, {420, 19 +21}, {421, 20 +21}, {422, 22 +21}, {423, 24 +21}, {423, 26 +21}, {424, 29 +21}, {424, 768 +21}, {424, 771 +21}, {423, 774 +21}, {422, 778 +21}, {421, 781 +21}, {420, 783 +21}, {419, 785 +21}, {418, 787 +21}, {416, 789 +21}, {415, 792 +21}, {413, 794 +21}, {412, 795 +21}, {410, 797 +21}, {408, 799 +21}, {405, 801 +21}, {403, 803 +21}, {401, 804 +21}, {397, 806 +21}, {394, 808 +21}, {392, 809 +21}, {390, 810 +21}, {387, 812 +21}, {385, 813 +21}, {382, 815 +21}, {380, 816 +21}, {378, 817 +21}, {376, 817 +21}, {374, 818 +21}, {372, 819 +21}, {370, 819 +21}, {53, 819+21}, {55, 819 +21}, {53, 819 +21}, {51, 818 +21}, {49, 817 +21}, {47, 816 +21}, {46, 816 +21}, {44, 815 +21}, {42, 815 +21}, {40, 814 +21}, {39, 813 +21}, {37, 812 +21}, {36, 811 +21}, {34, 811 +21}, {32, 810 +21}, {31, 809 +21}, {31, 809 +21}, {30, 808 +21}, {28, 807 +21}, {27, 806 +21}, {27, 805 +21}, {25, 805 +21}, {24, 804 +21}, {23, 803 +21}, {22, 803 +21}, {21, 802 +21}, {20, 801 +21}, {19, 800 +21}, {18, 799 +21}, {17, 798 +21}, {16, 797 +21}, {14, 795 +21}, {13, 794 +21}, {12, 793 +21}, {11, 791 +21}, {9, 788 +21}, {9, 787 +21}, {8, 784 +21}, {7, 782 +21}, {7, 781 +21}, {8, 779 +21}, {8, 777 +21}, {8, 775 +21}, {8, 774 +21}, {8, 772 +21}, {8, 29 +21}, {8, 27 +21}, {8, 25 +21}, {10, 24 +21}, {10, 23 +21}, {11, 22 +21}, {11, 21 +21}, {12, 20 +21}, {13, 19 +21}, {13, 18 +21}, {14, 17 +21}, {14, 16 +21}, {14, 15 +21}, {17, 14 +21}, {18, 13 +21}, {19, 12 +21}, {20, 12 +21}, {21, 11 +21}, {21, 10 +21}, {22, 10 +21}, {23, 9 +21}, {24, 8 +21}  };
		static POINT const table[114]= { {26, 10 +21}, {400, 10 +21}, {403, 10 +21}, {406, 10 +21}, {409, 10 +21}, {411, 10 +21}, {412, 10 +21}, {414, 11 +21}, {415, 12 +21}, {416, 13 +21}, {417, 14 +21}, {418, 15 +21}, {419, 17 +21}, {420, 19 +21}, {421, 20 +21}, {422, 22 +21}, {423, 24 +21}, {423, 26 +21}, {424, 29 +21}, {424, 768 +21}, {424, 771 +21}, {423, 774 +21}, {422, 778 +21}, {421, 781 +21}, {420, 783 +21}, {419, 785 +21}, {418, 787 +21}, {416, 789 +21}, {415, 792 +21}, {413, 794 +21}, {412, 795 +21}, {410, 797 +21}, {408, 799 +21}, {405, 801 +21}, {403, 803 +21}, {401, 804 +21}, {397, 806 +21}, {394, 808 +21}, {392, 809 +21}, {390, 810 +21}, {387, 812 +21}, {385, 813 +21}, {382, 815 +21}, {380, 816 +21}, {378, 817 +21}, {376, 817 +21}, {374, 818 +21}, {372, 819 +21}, {370, 819 +21}, {53, 819+21}, {55, 819 +21}, {53, 819 +21}, {51, 818 +21}, {49, 817 +21}, {47, 816 +21}, {46, 816 +21}, {44, 815 +21}, {42, 815 +21}, {40, 814 +21}, {39, 813 +21}, {37, 812 +21}, {36, 811 +21}, {34, 811 +21}, {32, 810 +21}, {31, 809 +21}, {31, 809 +21}, {30, 808 +21}, {28, 807 +21}, {27, 806 +21}, {27, 805 +21}, {25, 805 +21}, {24, 804 +21}, {23, 803 +21}, {22, 803 +21}, {21, 802 +21}, {20, 801 +21}, {19, 800 +21}, {18, 799 +21}, {17, 798 +21}, {16, 797 +21}, {14, 795 +21}, {13, 794 +21}, {12, 793 +21}, {11, 791 +21}, {9, 788 +21}, {9, 787 +21}, {8, 784 +21}, {8, 782 +21}, {8, 781 +21}, {8, 779 +21}, {8, 777 +21}, {8, 775 +21}, {8, 774 +21}, {8, 772 +21}, {9, 29 +21}, {9, 27 +21}, {9, 25 +21}, {10, 24 +21}, {10, 23 +21}, {12, 22 +21}, {12, 21 +21}, {13, 20 +21}, {14, 19 +21}, {14, 18 +21}, {15, 17 +21}, {15, 16 +21}, {17, 15 +21}, {18, 14 +21}, {20, 12 +21}, {21, 12 +21}, {22, 11 +21}, {23, 10 +21}, {24, 10 +21}, {25, 10 +21 }   };
		HRGN rgn = CreatePolygonRgn (table, 114, ALTERNATE);	
		SetWindowLong(m_hWnd, GWL_STYLE, GetWindowLong(m_hWnd, GWL_STYLE)&~WS_CAPTION); 
		SetWindowRgn(rgn, TRUE);
	}
	m_bHideTitlebar = !m_bHideTitlebar;	
}

/***************************************************************
** 
**  Called when the user presses 'About' sub-menu
**  
***************************************************************/
//
void CHP20b_cDlg::OnHelpAboutbox()
{
	CAboutDlg dlg;
	dlg.DoModal();
}

/***************************************************************
** 
**  Called when the user presses 'HP 20b Business Consultant Help' sub-menu
**  
***************************************************************/
//
void CHP20b_cDlg::OnHelpHp20bbusinessconsultant()
{
	HINSTANCE h = ShellExecute(NULL, "open", "20bHelpFile.chm", NULL, NULL, SW_SHOWNORMAL);
	// Returns a value greater than 32 if successful, or an error value 
	// that is less than or equal to 32 otherwise
	if( (int)h <= 32 )
		AfxMessageBox("The help file 20bHelpFile.chm was not found", MB_OK | MB_ICONINFORMATION);
}

/***************************************************************
** 
**  Called when the user presses 'Buy' sub-menu
**  
***************************************************************/
//
void CHP20b_cDlg::OnBuy()
{
	// Open default web browser
	ShellExecute(NULL, "open", "http://www.hp.com/calculators", NULL, NULL, SW_SHOWNORMAL);
}

/***************************************************************
** 
**  Resonsible to create the registry key and write the window's current 
**  coordinates and title bar visibility status to the registry.
**  
***************************************************************/
//
void CHP20b_cDlg::WriteToRegistry()
{
	RECT rect;
	HKEY hKey, hkResult;
    char pos[8];
	
	GetWindowRect(&rect);
	// Open/Create required registry and write values
	if( RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE",0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS){
		if(RegCreateKeyEx(hKey, "Hewlett-Packard" , 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkResult, NULL) == ERROR_SUCCESS){
			HKEY hkResult1;
			if( RegCreateKeyEx(hkResult, "hp20b" , 0, NULL, REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, NULL, &hkResult1, NULL)  == ERROR_SUCCESS){
				itoa(rect.left, pos, 10);
				if( RegSetValueEx(hkResult1, "left", 0, REG_SZ, (BYTE*)pos, lstrlen(pos)+1) == ERROR_SUCCESS){	
					itoa(rect.top, pos, 10);
					if( RegSetValueEx(hkResult1, "top", 0, REG_SZ, (BYTE*)pos, lstrlen(pos)+1) == ERROR_SUCCESS){
						sprintf(pos, "%d", m_bHideTitlebar);
						RegSetValueEx(hkResult1, "Titlebar", 0, REG_SZ, (BYTE*)pos, lstrlen(pos)+1);
					}
				}
			}
			RegCloseKey(hkResult1);
		}
	}
	
	RegCloseKey(hkResult);
	RegCloseKey(hKey);
}

/***************************************************************
** 
** Responsible to read retrieve left, top coordinates of the application 
** window and title bar visibility status from the registry.
**  
***************************************************************/
//
void CHP20b_cDlg::ReadRegistry()
{
	int  left, top;
	HKEY hKey;
	TCHAR data[8];
	DWORD dwBufLen = 8; // 8 Bytes
	
	// read registy and reterive values
	if( RegOpenKeyEx(HKEY_LOCAL_MACHINE, "SOFTWARE\\Hewlett-Packard\\hp20b", 0, KEY_QUERY_VALUE, &hKey) == ERROR_SUCCESS){
		if( RegQueryValueEx(hKey, "left",  NULL, NULL, (LPBYTE)data, &dwBufLen) == ERROR_SUCCESS)
			left = atoi(data); else left = 0;
	 	dwBufLen = 8;
		if(RegQueryValueEx(hKey, "top", NULL, NULL, (LPBYTE)data, &dwBufLen) == ERROR_SUCCESS)
			top = atoi(data); else	 top = 0;
		
		dwBufLen = 8;
		if(RegQueryValueEx(hKey, "Titlebar", NULL, NULL, (LPBYTE)data, &dwBufLen) == ERROR_SUCCESS)
			m_bHideTitlebar = atoi(data); else	m_bHideTitlebar = 0;
		RegCloseKey(hKey); hKey  = NULL;
	}
	
	RECT rect; GetClientRect(&rect);
	if(left < -(rect.right-rect.left)) left = 0;
	if(top < -(rect.bottom -rect.top)) top = 0;

	// change the window postion
	SetWindowPos(NULL, left, top, NULL, NULL, SWP_NOSIZE | SWP_NOZORDER | SWP_SHOWWINDOW);
	m_bHideTitlebar  = !m_bHideTitlebar;
	ShowHP20bTitlebar();

	//check/uncheck main menu
	CMenu *pMenu = GetMenu();
	if(m_bHideTitlebar)
		pMenu->CheckMenuItem(ID_HP20b_SHOWCAPTION, MF_BYCOMMAND | MF_CHECKED);
	else
		pMenu->CheckMenuItem(ID_HP20b_SHOWCAPTION, MF_BYCOMMAND | MF_UNCHECKED);
}


/***************************************************************
** 
**  Called when the user chooses 'Hide Titlebar' sub-menu from the main menu
**  
***************************************************************/
//
void CHP20b_cDlg::OnHP20bShowcaptionMenu()
{
	ShowHP20bTitlebar();

	// check/uncheck main menu
	CMenu *pMenu = GetMenu();
	if(m_bHideTitlebar)
		pMenu->CheckMenuItem(ID_HP20b_SHOWCAPTION, MF_BYCOMMAND | MF_CHECKED);
	else
		pMenu->CheckMenuItem(ID_HP20b_SHOWCAPTION, MF_BYCOMMAND | MF_UNCHECKED);

	AfxMessageBox("Right click on the HP logo and unckeck 'Hide Titlebar' to display the titlebar\r\n"
	              "to close the calculator, turn it OFF (pressing the second function key and the ON/CE key)", MB_OK | MB_ICONINFORMATION);
}

/***************************************************************
** 
**  Called when the user chooses test bench menu
**  
***************************************************************/
//
void CHP20b_cDlg::UpdateTestbenchMenu(CMenu *pShortCutMenu)
{
	if(pShortCutMenu != NULL){
		pShortCutMenu->CheckMenuItem(ID_HP20b_PCCALC1, MF_BYCOMMAND | MF_UNCHECKED);
		pShortCutMenu->CheckMenuItem(ID_HP20b_PCCALC2, MF_BYCOMMAND | MF_UNCHECKED);
		pShortCutMenu->CheckMenuItem(ID_HP20b_PCCALC3, MF_BYCOMMAND | MF_UNCHECKED);
		pShortCutMenu->CheckMenuItem(ID_HP20b_PCCALC4, MF_BYCOMMAND | MF_UNCHECKED);
		pShortCutMenu->CheckMenuItem(ID_HP20b_PCCALC5, MF_BYCOMMAND | MF_UNCHECKED);
		pShortCutMenu->CheckMenuItem(m_nCurrentTestbenchId, MF_BYCOMMAND | MF_CHECKED);
	}
	CMenu *pMenu = GetMenu();
	pMenu->CheckMenuItem(ID_HP20b_PCCALC1, MF_BYCOMMAND | MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_HP20b_PCCALC2, MF_BYCOMMAND | MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_HP20b_PCCALC3, MF_BYCOMMAND | MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_HP20b_PCCALC4, MF_BYCOMMAND | MF_UNCHECKED);
	pMenu->CheckMenuItem(ID_HP20b_PCCALC5, MF_BYCOMMAND | MF_UNCHECKED);
	pMenu->CheckMenuItem(m_nCurrentTestbenchId, MF_BYCOMMAND | MF_CHECKED);
}
