/*
Copyright (c) 2007 Hewlett-Packard development company llc
//
//  All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//  - Redistributions of source code must retain the above copyright notice,
//  this list of conditions and the disclaimer below.
//
//  - Redistributions in binary form must reproduce the above copyright notice,
//  this list of conditions and the disclaimer below in the documentation and/or
//  other materials provided with the distribution. Unless a specific license is granted
//  to te licencee
//
//  - This software can only be used on a HP hardware. You are not permited to leaverage
//  any part of this software for products/project that do not work on hardware sold by HP
//
//  HP's name may not be used to endorse or promote products derived from
//  this software without specific prior written permission.
//
//  DISCLAIMER:  THIS SOFTWARE IS PROVIDED BY HP "AS IS" AND ANY EXPRESS OR
//  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
//  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
//  DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
//  OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
//  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//  ----------------------------------------------------------------------------
file created by Cyrille de Brebisson
*/

#include "application.h"
#include "graphics.h"
#include <stdio.h>

#ifdef _ARM_
#else
TMyApplication MYAPPLICATION;
#endif

void updatescreen(TMyApplication *MyApplication)
{
  if (MyApplication->state==StateEntry)
  {
    DispChars("Number?", 0, 0);
    char s[15];
    sprintf(s, "%u", MyApplication->userentry);
    DispNumber(s);
  } else if (MyApplication->state==StateComparison)
  {
    if (MyApplication->TargetNumber>MyApplication->userentry)
      DispChars("Too Small", 0, 0);
    else
      DispChars("Too Big", 0, 0);
    char s[15];
    sprintf(s, "%u", MyApplication->userentry);
    DispNumber(s);
  } else if (MyApplication->state==StateWon)
  {
    DispChars("WON!", 0, 0);
    char s[15];
    sprintf(s, "%u", MyApplication->tryCounter);
    DispNumber(s);
  }
}

void newNumber(TMyApplication *MyApplication)
{
  MyApplication->userentry= 0;
  MyApplication->tryCounter= 0;
  MyApplication->state= StateEntry;
  MyApplication->TargetNumber= (MyApplication->TargetNumber*0x74854741+0x14574236)%10000; // random generator work like that... realy... except that I did not bother looking for good prime numbers but just typed random numbers there... so don't reuse this code!!!!
}

void number(TMyApplication *MyApplication, int n)
{
  if (MyApplication->state!=StateEntry)
    if (MyApplication->state!=StateComparison)
      newNumber(MyApplication);
    else {
      MyApplication->userentry= 0;
      MyApplication->state= StateEntry;
    }
  unsigned long long t= (unsigned long long)MyApplication->userentry*10ULL+(unsigned long long)n;
  if (t<=0xffffffffULL) 
    MyApplication->userentry= (unsigned int) t; 
}
bool KeyPress(int key)
{
  // do what needs to be done if the key is pressed.
  // key are encoded as r*10+c where r is the row and c is the column.
  // ENTER is 31 for example
  switch (key)
  {
  case 31: 
    MyApplication->tryCounter++;
    if (MyApplication->TargetNumber==MyApplication->userentry) 
      MyApplication->state=StateWon; 
    else
      MyApplication->state= StateComparison;
    break;
  case 42: number(MyApplication, 7); break;
  case 43: number(MyApplication, 8); break;
  case 44: number(MyApplication, 9); break;
  case 52: number(MyApplication, 4); break;
  case 53: number(MyApplication, 5); break;
  case 54: number(MyApplication, 6); break;
  case 62: number(MyApplication, 1); break;
  case 63: number(MyApplication, 2); break;
  case 64: number(MyApplication, 3); break;
  case 72: number(MyApplication, 0); break;
  case 35: if (MyApplication->state==StateEntry) MyApplication->userentry/= 10; break;
  case 71: if (MyApplication->state==StateEntry) MyApplication->userentry= 0; else newNumber(MyApplication); break;
  }
  updatescreen(MyApplication);
  return false;
}

void init()
{
  // initialization code for your application (equivalent to boot on the real device)
  MyApplication->TargetNumber= 0x41254774;
  MyApplication->Marker= MagicMarker;
  MyApplication->contrast= 9;
  newNumber(MyApplication);
  updatescreen(MyApplication);
}
bool IsShift()
{
  return false;
}
