/*
Copyright (c) 2007 Hewlett-Packard development company llc
//
//  All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//  - Redistributions of source code must retain the above copyright notice,
//  this list of conditions and the disclaimer below.
//
//  - Redistributions in binary form must reproduce the above copyright notice,
//  this list of conditions and the disclaimer below in the documentation and/or
//  other materials provided with the distribution. Unless a specific license is granted
//  to te licencee
//
//  - This software can only be used on a HP hardware. You are not permited to leaverage
//  any part of this software for products/project that do not work on hardware sold by HP
//
//  HP's name may not be used to endorse or promote products derived from
//  this software without specific prior written permission.
//
//  DISCLAIMER:  THIS SOFTWARE IS PROVIDED BY HP "AS IS" AND ANY EXPRESS OR
//  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
//  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
//  DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
//  OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
//  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//  ----------------------------------------------------------------------------
file created by Cyrille de Brebisson
*/

#include "graphics.h"
#ifdef _ARM_
#include "board.h"
#endif

static unsigned char const Table_Matrix[][7]={
5, 0, 0, 0, 0, 0, 0,
2, 1, 1, 1, 1, 0, 1, 
4, 5, 5, 5, 0, 0, 0, 
6, 0, 10, 31, 10, 31, 10, 
6, 4, 30, 5, 14, 20, 15, 
6, 0, 18, 8, 4, 2, 9, 
6, 6, 9, 6, 25, 9, 22, 
2, 1, 1, 1, 0, 0, 0, 
3, 2, 1, 1, 1, 1, 2, 
3, 1, 2, 2, 2, 2, 1, 
6, 0, 10, 4, 31, 4, 10, 
6, 0, 4, 4, 31, 4, 4, 
3, 0, 0, 3, 3, 2, 1, 
6, 0, 0, 0, 31, 0, 0, 
3, 0, 0, 0, 0, 3, 3, 
6, 0, 16, 8, 4, 2, 1, 
6, 14, 17, 25, 21, 19, 14, 
4, 2, 3, 2, 2, 2, 7, 
6, 14, 17, 16, 12, 2, 31, 
6, 14, 17, 12, 16, 17, 14, 
6, 12, 10, 9, 31, 8, 8, 
6, 31, 1, 15, 16, 16, 15, 
6, 14, 1, 15, 17, 17, 14, 
6, 31, 16, 8, 4, 4, 4, 
6, 14, 17, 14, 17, 17, 14, 
6, 14, 17, 17, 30, 16, 14, 
3, 0, 3, 3, 0, 3, 3, 
3, 0, 3, 3, 0, 3, 2, 
4, 8, 4, 2, 1, 2, 4, 
6, 0, 0, 31, 0, 31, 0, 
4, 1, 2, 4, 8, 4, 2, 
6, 14, 17, 8, 4, 0, 4,
6, 14, 17, 21, 29, 1, 14, 
6, 14, 17, 17, 31, 17, 17, 
6, 15, 17, 15, 17, 17, 15, 
6, 14, 17, 1, 1, 17, 14, 
6, 15, 17, 17, 17, 17, 15, 
6, 31, 1, 15, 1, 1, 31, 
6, 31, 1, 15, 1, 1, 1, 
6, 14, 17, 1, 25, 17, 14, 
6, 17, 17, 17, 31, 17, 17, 
6, 31, 4, 4, 4, 4, 31, 
6, 16, 16, 16, 17, 17, 14, 
6, 17, 9, 7, 9, 17, 17, 
6, 1, 1, 1, 1, 1, 31, 
6, 17, 27, 21, 17, 17, 17, 
6, 17, 17, 19, 21, 25, 17, 
6, 14, 17, 17, 17, 17, 14, 
6, 15, 17, 17, 15, 1, 1, 
6, 14, 17, 17, 21, 9, 22, 
6, 15, 17, 17, 15, 17, 17, 
6, 14, 17, 6, 8, 17, 14, 
6, 31, 4, 4, 4, 4, 4, 
6, 17, 17, 17, 17, 17, 14, 
6, 17, 17, 17, 17, 10, 4, 
6, 17, 17, 17, 21, 27, 17, 
6, 17, 17, 10, 4, 10, 17, 
6, 17, 17, 10, 4, 4, 4, 
6, 31, 8, 4, 2, 1, 31, 
4, 7, 1, 1, 1, 1, 7, 
6, 0, 1, 2, 4, 8, 16, 
4, 7, 4, 4, 4, 4, 7, 
6, 4, 10, 17, 0, 0, 0, 
6, 0, 0, 0, 0, 0, 31, 
2, 1, 1, 2, 0, 0, 0, 
5, 0, 0, 7, 14, 9, 14, 
5, 1, 1, 7, 9, 9, 7, 
5, 0, 0, 6, 1, 1, 14, 
5, 8, 8, 14, 9, 9, 14, 
5, 0, 0, 6, 15, 1, 6, 
5, 6, 9, 1, 3, 1, 1, 
5, 0, 6, 9, 14, 8, 7, 
5, 1, 1, 7, 9, 9, 9, 
2, 0, 1, 0, 1, 1, 1, 
5, 8, 0, 12, 8, 9, 6, 
5, 1, 1, 9, 7, 9, 9, 
4, 3, 2, 2, 2, 2, 7, 
6, 0, 0, 15, 21, 17, 17, 
5, 0, 0, 7, 9, 9, 9, 
5, 0, 0, 6, 9, 9, 6, 
5, 0, 7, 9, 9, 7, 1, 
5, 0, 14, 9, 9, 14, 8, 
5, 0, 0, 13, 3, 1, 1, 
5, 0, 0, 14, 7, 8, 7, 
5, 1, 1, 7, 1, 9, 6, 
5, 0, 0, 9, 9, 9, 14, 
5, 0, 0, 9, 9, 5, 3, 
6, 0, 0, 17, 21, 21, 15, 
5, 0, 0, 9, 6, 6, 9, 
5, 0, 9, 9, 14, 8, 6, 
5, 0, 0, 15, 4, 2, 15, 
4, 6, 2, 1, 2, 6, 0, 
2, 1, 1, 1, 1, 1, 1, 
3, 3, 2, 4, 2, 3, 0, 
6, 0, 2, 21, 8, 0, 0, 
7, 21, 42, 21, 42, 21, 42, 
5, 0, 8, 4, 2, 5, 15, 
5, 15, 0, 9, 6, 6, 9, 
6, 31, 0, 9, 10, 4, 3, 
6, 28, 4, 4, 5, 6, 4, 
6, 8, 20, 20, 5, 5, 2, 
5, 15, 2, 4, 2, 1, 15, 
5, 3, 7, 15, 15, 7, 3, 
6, 1, 31, 10, 10, 10, 10, 
5, 2, 4, 14, 9, 9, 6, 
5, 8, 4, 2, 15, 0, 15, 
5, 1, 2, 4, 15, 0, 15, 
5, 0, 8, 15, 6, 15, 1, 
6, 0, 0, 22, 9, 9, 22, 
6, 0, 4, 8, 31, 8, 4, 
6, 0, 4, 2, 31, 2, 4, 
6, 0, 4, 4, 21, 14, 4, 
6, 0, 4, 14, 21, 4, 4, 
6, 0, 0, 18, 21, 8, 8, 
5, 2, 4, 14, 9, 9, 6, 
4, 0, 6, 1, 7, 1, 6, 
6, 0, 10, 21, 20, 16, 16, 
5, 0, 6, 9, 15, 9, 6, 
6, 0, 1, 2, 4, 10, 17, 
6, 12, 18, 18, 14, 2, 1, 
6, 0, 0, 30, 9, 9, 6, 
6, 0, 0, 30, 5, 20, 8, 
6, 0, 0, 9, 17, 21, 10, 
6, 0, 4, 10, 17, 31, 0, 
6, 31, 10, 10, 10, 10, 10, 
6, 14, 17, 17, 17, 10, 27, 
5, 0, 0, 14, 14, 14, 0, 
6, 0, 0, 10, 21, 21, 10, 
6, 28, 2, 15, 7, 2, 28, 
2, 2, 0, 2, 2, 2, 2, 
5, 4, 14, 5, 5, 14, 4, 
5, 4, 10, 2, 7, 2, 15, 
5, 9, 6, 9, 9, 6, 9, 
6, 17, 10, 31, 4, 31, 4, 
3, 0, 4, 4, 0, 4, 4, 
5, 4, 2, 6, 9, 6, 4, 
5, 10, 0, 0, 0, 0, 0, 
6, 17, 23, 19, 23, 17, 14, 
5, 8, 14, 9, 6, 15, 0, 
6, 0, 20, 10, 5, 10, 20, 
5, 0, 0, 0, 15, 8, 0, 
5, 0, 0, 0, 15, 0, 0, 
6, 17, 23, 23, 27, 17, 14, 
5, 15, 0, 0, 0, 0, 0, 
5, 14, 10, 14, 0, 0, 0, 
5, 0, 4, 14, 4, 14, 0, 
4, 7, 4, 7, 1, 7, 0, 
4, 4, 7, 4, 7, 0, 0, 
6, 8, 12, 9, 28, 0, 0, 
6, 0, 9, 9, 9, 23, 1, 
6, 30, 23, 23, 22, 20, 22, 
4, 0, 0, 6, 6, 0, 0, 
3, 0, 0, 0, 0, 4, 3, 
5, 4, 4, 14, 0, 0, 0, 
5, 9, 9, 6, 0, 15, 0, 
6, 0, 5, 10, 20, 10, 5, 
6, 9, 5, 2, 21, 28, 16, 
6, 9, 5, 26, 17, 8, 24, 
6, 18, 11, 6, 23, 28, 16, 
6, 4, 0, 4, 2, 1, 17, 
5, 4, 6, 9, 15, 9, 9, 
5, 2, 6, 9, 15, 9, 9, 
5, 9, 0, 6, 9, 15, 9, 
5, 5, 6, 9, 15, 9, 9, 
5, 0, 6, 9, 15, 9, 9, 
5, 9, 6, 9, 15, 9, 9, 
5, 10, 5, 5, 15, 5, 13, 
5, 6, 9, 1, 9, 6, 4, 
5, 4, 15, 1, 7, 1, 15, 
5, 4, 15, 1, 7, 1, 15, 
5, 10, 15, 1, 7, 1, 15, 
5, 0, 15, 1, 7, 1, 15, 
4, 2, 7, 2, 2, 2, 7, 
4, 2, 7, 2, 2, 2, 7, 
4, 5, 7, 2, 2, 2, 7, 
4, 0, 7, 2, 2, 2, 7, 
6, 14, 18, 18, 19, 18, 14, 
5, 5, 0, 9, 11, 13, 9, 
5, 4, 6, 9, 9, 9, 6, 
5, 4, 6, 9, 9, 9, 6, 
5, 9, 6, 9, 9, 9, 6, 
5, 5, 6, 9, 9, 9, 6, 
5, 0, 6, 9, 9, 9, 6, 
6, 0, 17, 10, 4, 10, 17, 
6, 14, 25, 21, 19, 14, 1, 
5, 2, 9, 9, 9, 9, 6, 
5, 4, 9, 9, 9, 9, 6, 
5, 9, 0, 9, 9, 9, 6, 
5, 0, 9, 9, 9, 9, 6, 
5, 4, 9, 9, 14, 8, 7, 
6, 2, 14, 18, 14, 2, 7, 
6, 6, 5, 15, 17, 15, 1, 
5, 4, 0, 7, 14, 9, 14, 
5, 4, 0, 7, 14, 9, 14, 
5, 9, 0, 7, 14, 9, 14, 
5, 5, 0, 7, 14, 9, 14, 
5, 9, 0, 7, 14, 9, 14, 
5, 5, 2, 7, 14, 9, 14, 
6, 0, 27, 20, 31, 5, 31, 
5, 0, 6, 1, 1, 14, 4, 
5, 4, 0, 6, 15, 1, 6, 
5, 2, 0, 6, 15, 1, 6, 
5, 10, 0, 6, 15, 1, 6, 
5, 10, 0, 6, 15, 1, 6, 
3, 2, 4, 0, 4, 4, 4, 
4, 8, 4, 0, 4, 4, 4, 
5, 4, 10, 0, 4, 4, 4, 
5, 0, 10, 0, 4, 4, 4, 
6, 28, 8, 14, 9, 9, 6, 
5, 5, 0, 7, 9, 9, 9, 
5, 4, 0, 6, 9, 9, 6, 
5, 2, 0, 6, 9, 9, 6, 
5, 10, 0, 6, 9, 9, 6, 
5, 5, 0, 6, 9, 9, 6, 
5, 10, 0, 6, 9, 9, 6, 
4, 0, 2, 0, 7, 0, 2, 
6, 0, 22, 9, 21, 18, 13, 
5, 4, 0, 9, 9, 9, 14, 
5, 2, 0, 9, 9, 9, 14, 
5, 9, 0, 9, 9, 9, 14, 
5, 9, 0, 9, 9, 9, 14, 
5, 2, 0, 9, 9, 14, 8, 
5, 1, 7, 9, 9, 7, 1, 
5, 9, 0, 9, 9, 14, 8, 

};

__arm void DispGraphic(unsigned long long int *grob)
{
  unsigned long long *pLCD = (unsigned long long *)AT91C_SLCDC_MEM;
  //6*33 horizontal matrix transfert
  pLCD[6]= (pLCD[6]&~0x7fffffffc0LL) | ((grob[0]<<6)&0x7fffffffc0LL);
  pLCD[7]= (pLCD[7]&~0x7fffffffc0LL) | ((grob[1]<<6)&0x7fffffffc0LL);
  pLCD[8]= (pLCD[8]&~0x7fffffffc0LL) | ((grob[2]<<6)&0x7fffffffc0LL);
  pLCD[9]= (pLCD[9]&~0x7fffffffc0LL) | ((grob[3]<<6)&0x7fffffffc0LL);
  pLCD[0]= (pLCD[0]&~0x7fffffffc0LL) | ((grob[4]<<6)&0x7fffffffc0LL);
  pLCD[1]= (pLCD[1]&~0x7fffffffc0LL) | ((grob[5]<<6)&0x7fffffffc0LL);
  //now the verticals...
  for (int j=9; j>=0; j--)
  { 
    char const tr[]={ 2, 3, 4, 5, 6, 7, 8, 9, 0, 1};
    unsigned int c=0; 
    for (int i=0; i<6; i++) 
    { c=(c<<1); if ((grob[i]&(1LL<<(j+33)))!=0) c++; }
    pLCD[tr[j]]= (pLCD[tr[j]]&~0x3fLL) | (unsigned long long)c;
  }
}

__arm int DispChars(char const *msg, int offset, bool loop)
{
  char const *pMsg = msg;
  int linecount= 0;
  unsigned long long matrix[6]={0, 0, 0, 0, 0, 0};
  for (;;)
  {
    int s= Table_Matrix[((*pMsg)<32?32:(*pMsg)-32)][0];
    if (offset-s<0) break;
    if (*pMsg!=0) pMsg++;
    else if (loop) pMsg= msg, linecount++; else { DispGraphic(matrix); return 0; } 
    offset= offset-s;
    if (offset==0) break;
  }

  offset= -offset;
  while (offset<=43)
  {
    unsigned char const *a= &Table_Matrix[*pMsg<32?0:(*pMsg)-32][1];
    if (offset<0)
      for (int rows_count = 0; rows_count <=5; rows_count++)
        matrix[rows_count]|= ((unsigned long long)(*a++))>>(-offset);
    else
      for (int rows_count = 0; rows_count <=5; rows_count++)
        matrix[rows_count]|= ((unsigned long long)(*a++))<<offset;
    offset+= a[-7];
    if (loop) { if (*pMsg==0) pMsg= msg; else pMsg++; }
    else { if (*pMsg==0) break; pMsg++; if (*pMsg==0) break; }
  }
  DispGraphic(matrix);
  if (loop) return linecount; else if (*pMsg==0) return offset-1; else return 44;
}


// 1 char definition defines all 11 segments of the char in the following order:
// top, top left, top right, middle, bottom left, bottom right, bottom, . and ,
// each segment has 2 bytes collumn and common in that order
// if the segment does not exist, the value of -1 is in the common
typedef struct { signed char rc[9*2]; } TCharDef;
static TCharDef const CharDef[17] = //7
//   top     tleft    tright    middle   bleft    bright   botom      .       ,
{ { -1, -1,  -1, -1,  -1, -1,   6,  5,  -1, -1,  -1, -1,  -1, -1,  -1, -1,  -1, -1}, //-1 -
  {  7,  2,   6,  2,   8,  2,   7,  3,   6,  3,   7,  4,   6,  4,   8,  5,   7,  5}, //0 character 0
  {  9,  2,   8,  3,  10,  3,   9,  3,   8,  4,  10,  4,   9,  4,  10,  5,   9,  5}, //1 character 1
  { 11,  2,  10,  2,  12,  2,  11,  3,  11,  4,  12,  3,  11,  5,  12,  4,  12,  5}, //2 character 2
  { 14,  2,  13,  2,  14,  3,  13,  3,  13,  4,  14,  4,  13,  5,  15,  4,  14,  5}, //3 character 3
  { 16,  2,  15,  2,  17,  2,  16,  3,  15,  3,  16,  4,  15,  5,  17,  5,  16,  5}, //4 character 4
  { 18,  2,  17,  3,  19,  3,  18,  3,  17,  4,  19,  4,  18,  4,  19,  5,  18,  5}, //5 character 5
  { 20,  2,  19,  2,  21,  2,  20,  3,  20,  4,  21,  3,  20,  5,  21,  4,  21,  5}, //6 character 6
  { 23,  2,  22,  2,  23,  3,  22,  3,  22,  4,  23,  4,  22,  5,  24,  4,  23,  5}, //7 character 7
  { 25,  2,  24,  2,  26,  2,  25,  3,  24,  3,  25,  4,  24,  5,  26,  5,  25,  5}, //8 character 8
  { 27,  2,  26,  3,  28,  3,  27,  3,  26,  4,  28,  4,  27,  4,  28,  5,  27,  5}, //9 character 9
  { 29,  2,  28,  2,  30,  2,  29,  3,  29,  4,  30,  3,  29,  5,  30,  4,  30,  5}, //10 character 10
  { 32,  2,  31,  2,  32,  3,  31,  3,  31,  4,  32,  4,  31,  5,  33,  5,  32,  5}, //11 character 11
  { -1, -1,  -1, -1,  -1, -1,  33,  3,  -1, -1,  -1, -1,  -1, -1,  -1, -1,  -1, -1}, //12 exponent sign
  { 34,  2,  33,  2,  34,  3,  34,  4,  33,  4,  35,  5,  34,  5,  -1, -1,  -1, -1}, //13 exponent 0
  { 36,  2,  35,  2,  36,  3,  35,  3,  35,  4,  36,  4,  36,  5,  -1, -1,  -1, -1}, //14 exponent 1
  { 38,  3,  37,  2,  38,  4,  37,  3,  37,  4,  38,  5,  37,  5,  -1, -1,  -1, -1}  //15 exponent 2
};
#define t 1
#define tl 2
#define tr 4
#define m 8
#define bl 16
#define br 32
#define b 64
#define p 128
#define c 256 
typedef struct { char ch; int def; } TChrDef;
static TChrDef const chrsDef[] = { 
  { '0', t|tl|tr|bl|br|b },
  { '1', tr|br },
  { '2', t|tr|m|bl|b },
  { '3', t|tr|m|br|b },
  { '4', tl|tr|m|br },
  { '5', t|tl|m|br|b },
  { '6', t|tl|m|bl|br|b },
  { '7', t|tr|br },
  { '8', t|tr|tl|m|br|bl|b },
  { '9', t|tr|tl|m|br|b },
  { '-', m },
  { '.', p },
  { ',', p|c },
  { ' ', 0},
  { '_', b},
  { 0, 0 }
};
#undef t 
#undef tl
#undef tr 
#undef m 
#undef bl 
#undef br 
#undef b 
#undef p 
#undef c 
// chrNumber starts at -1 (for the - sign)
// chrs 0 to 11 are the 12 big numbers
// chr 12 is the - sign of exponent
// chr 13, 14 and 15 are the exponents
__arm void DispOnNumber(int chrNumber, char character, int coma) 
{
  chrNumber++;
  if (chrNumber<0 || chrNumber>16) return;
  unsigned long long *pLCD= (unsigned long long *)AT91C_SLCDC_MEM;
  int cd;
  if (character>='0' && character<='9') cd= chrsDef[character-'0'].def; 
  else if (character=='-') cd= chrsDef[10].def;
  else if (character=='_') cd= chrsDef[14].def;
  else cd= 0; 
  if (coma==1) cd|= chrsDef[11].def;
  else if (coma==2) cd|= chrsDef[12].def;
  for (int i=0; i<9; i++)
  {
    unsigned long long mask= 1LL<<CharDef[chrNumber].rc[i*2];
    int com= CharDef[chrNumber].rc[i*2+1];
    if ((cd&1) != 0) pLCD[com]|= mask; else pLCD[com]&= ~mask;
    cd>>= 1;
  }
}  

void DispNumber(char const *numStrng)
{
  int pos= -1;
  if (*numStrng=='-')
    DispOnNumber(pos++, *numStrng++, 0);
  else
    DispOnNumber(pos++, ' ', 0);
  while(*numStrng!=0)
  {
    if (*numStrng!='E')
    {
      int coma;
      char c= *numStrng++;
      if (*numStrng=='.') coma= 1, numStrng++; 
      else if (*numStrng==',') coma= 2, numStrng++;
      else coma= 0;
      DispOnNumber(pos++, c, coma);
    }
    else
    {
      while (pos<12) DispOnNumber(pos++, ' ', 0);
      numStrng++;
      if (*numStrng=='-')
        DispOnNumber(pos++, *numStrng++, 0);
      else
        DispOnNumber(pos++, ' ', 0);
    }
  }
  while (pos<16) DispOnNumber(pos++, ' ', 0);
}
 
 //each Indicator is represented by pair of bytes (Segment, Common).
static unsigned char const tableIndics[] = {
  //BIG_EQUAL	  DOWN_ARROW	 INPUT	SMALL_EQUAL	  BAT	 BEG	
    39,1,         39,0,          39,9,  39,8,         39,7,  39,6,
  //STO			RCL		  RAD	 THREE_SIXTY    RPN			
    39,5,       39,4,     39,3,  39,2,          38,2,
};
void DispIndicator(unsigned int indic, bool on)
{
  unsigned long long *pLCD;
  unsigned long long mask;
  
  pLCD = (unsigned long long *) (AT91C_SLCDC_MEM);
  mask = 0x1LL<< *(tableIndics+(indic*2));
  int com = *(tableIndics + (indic*2)+1);
  if(on) *(pLCD+com) |= mask;
  else *(pLCD+com) &= ~mask;
}
