/*
Copyright (c) 2007 Hewlett-Packard development company llc
//
//  All rights reserved.
//
//  Redistribution and use in source and binary forms, with or without
//  modification, are permitted provided that the following conditions are met:
//
//  - Redistributions of source code must retain the above copyright notice,
//  this list of conditions and the disclaimer below.
//
//  - Redistributions in binary form must reproduce the above copyright notice,
//  this list of conditions and the disclaimer below in the documentation and/or
//  other materials provided with the distribution. Unless a specific license is granted
//  to te licencee
//
//  - This software can only be used on a HP hardware. You are not permited to leaverage
//  any part of this software for products/project that do not work on hardware sold by HP
//
//  HP's name may not be used to endorse or promote products derived from
//  this software without specific prior written permission.
//
//  DISCLAIMER:  THIS SOFTWARE IS PROVIDED BY HP "AS IS" AND ANY EXPRESS OR
//  IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
//  MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT ARE
//  DISCLAIMED. IN NO EVENT SHALL ATMEL BE LIABLE FOR ANY DIRECT, INDIRECT,
//  INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
//  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA,
//  OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
//  LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
//  NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
//  EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//  ----------------------------------------------------------------------------
file created by Cyrille de Brebisson
*/
#ifndef _ARM_
#define __arm
#define __noinit
void UpdateDlgScreen();
void CopyBitmapToClipboard();
void WindowsBlink(bool blink);
void WindowsSwapBuffers();
extern unsigned int LcdData[20];
unsigned int * const AT91C_SLCDC_MEM=LcdData;
void inline Lcd_Enable(int contrast) { }
#else
//#define UpdateScreenContent()
#define WindowsSwapBuffers()
#define UpdateDlgScreen()
#endif

#define BIG_EQUAL	  0
#define DOWN_ARROW	  1
#define INPUT		  2
#define SMALL_EQUAL	  3
#define BAT			  4
#define BEG			  5
#define STO			  6
#define RCL			  7
#define RAD			  8
#define THREE_SIXTY   9
#define RPN			  10


/**! \fn DispGraphic(unsigned long long int *grob)
 *  @ingroup lcddriver
 * \brief display the 43*6 gaphic pointed by grob on the 43*6 matrix on the screen
 **/
__arm void DispGraphic(unsigned long long int *grob);
/**! \fn DispChars(char const *s, int offset)
 *  @ingroup lcddriver
 * \brief display the text message pointed by s on the matrix area of the screen. the first chr is offseted to the left by offset pixcels
 * \if loop is true, then display the message in a loop (ie, if it reaches the end of the text before the end of the screen, it adds a space and restarts from the begining of the text)
 * \ returns the number of times that the function had to go though the whole message in loop mode...
 *  \if loop is set to false, returns the number of pixcel that it took to display the text...
 **/
__arm int DispChars(char const *s, int offset, bool loop);
void DispNumber(char const *s);

/**! \fn DispIndicator(unsigned long long indic, bool on)
 *  @ingroup lcddriver
 * \brief turn given indicator on or off
 **/
void DispIndicator(unsigned int indic, bool on);

/**! \fn The bellow functions are used by the Display APIs
 *  @ingroup lcddriver
 * \brief This functions are  called by the Display APIs
 **/
